'Imports Microsoft.Office.Interop

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Button2 = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(16, 24)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(128, 40)
        Me.Button1.TabIndex = 5
        Me.Button1.Text = "Access aufrufen"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(240, 24)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(120, 40)
        Me.Button2.TabIndex = 6
        Me.Button2.Text = "Beenden"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(384, 85)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button2, Me.Button1})
        Me.Name = "Form1"
        Me.Text = "MS Access ber Automation steuern"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Access aufrufen:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Show_Form()
    End Sub

    ' Anzeige des Formulars "" von der Datenbank Test.mdb
    ' und Manipulation einiger Steuerelemente

    Private Sub Show_Form()

        On Error GoTo ErrorHandler

        Dim oAccess As Access.Application
        Dim oForm As Access.Form
        Dim oCtls As Access.Controls
        Dim oCtl As Access.Control
        Dim dbPath As String           ' Datenbankpfad zu Test.mdb
        Dim aForm As String             ' Name des anzuzeigenden Formulars

        aForm = "Bericht aufrufen"

        ' Eine neue Access-Instanz fr die Automation starten:
        oAccess = New Access.ApplicationClass()

        ' Absichern, dass Access sichtbar ist:
        If Not oAccess.Visible Then oAccess.Visible = True

        ' Datenbankpfad ermitteln (die Datenbank befindet sich im Anwendungsverzeichnis!):
        dbPath = Application.StartupPath & "\Test.mdb"

        ' Datenbank ffnen (im Shared Mode):
        oAccess.OpenCurrentDatabase(filepath:=dbPath, Exclusive:=False)

        ' Eventuell geffnete Formulare schlieen:
        For Each oForm In oAccess.Forms
            oAccess.DoCmd.Close(ObjectType:=Access.AcObjectType.acForm, _
                ObjectName:=oForm.Name, Save:=Access.AcCloseSave.acSaveNo)
        Next
        If Not oForm Is Nothing Then
            System.Runtime.InteropServices.Marshal.ReleaseComObject(oForm)
        End If
        oForm = Nothing

        ' Formular im Datenbankfenster auswhlen und Fokus erteilen:
        oAccess.DoCmd.SelectObject(ObjectType:=Access.AcObjectType.acForm, _
            ObjectName:=aForm, InDatabaseWindow:=True)

        ' Formular anzeigen:
        oAccess.DoCmd.OpenForm(FormName:=aForm, View:=Access.AcFormView.acNormal)
        ' Die berschrift des Formulars editieren:
        oForm = oAccess.Forms(aForm)
        oForm.Caption = "Access-Automation mit Visual Basic .NET"
        ' Benutzen der Controls-Auflistung, um Steuerelemente zu editieren:
        oCtls = oForm.Controls
        ' Die Beschriftung der Schaltflche "Befehl1" wird gendert:
        oCtl = oCtls.Item("Befehl1")
        oCtl.Caption = "Report aufrufen" 'second option in option group
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oCtl)
        oCtl = Nothing

        ' Datenbankfenster verstecken:
        oAccess.DoCmd.SelectObject(ObjectType:=Access.AcObjectType.acForm, _
            ObjectName:=aForm, InDatabaseWindow:=True)
        oAccess.RunCommand(Command:=Access.AcCommand.acCmdWindowHide)

        ' Formular erhlt Fokus zurck:
        oForm.SetFocus()

        ' Objekte freigeben:
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oCtls)
        oCtls = Nothing
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oForm)
        oForm = Nothing

        ' Application Objekt freigeben und erlauben, dass Access durch den Anwender geschlossen wird:
        If Not oAccess.UserControl Then oAccess.UserControl = True
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oAccess)
        oAccess = Nothing

        Exit Sub
ErrorCleanup:
        ' Bei einem unewarteten Fehler wird versucht, Access u shlieen:
        On Error Resume Next
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oCtl)
        oCtl = Nothing
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oCtls)
        oCtls = Nothing
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oForm)
        oForm = Nothing
        oAccess.Quit(Option:=Access.AcQuitOption.acQuitSaveNone)
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oAccess)
        oAccess = Nothing

        Exit Sub
ErrorHandler:
        MsgBox(Err.Number & ": " & Err.Description, MsgBoxStyle.MsgBoxSetForeground, "Error Handler")
        Resume ErrorCleanup
    End Sub

    ' Beenden:
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub
End Class
